

color white, black;


// color changes with the background
color back; // color of the background



float shiftx=840; //shift of the main field
float shifty=90;

float shifth=30; //shift of the hue slider from the main field
float band=30; // hue slider width

float cell=1; //cell size
float huee, satu, brig;

float frame=30; //white background for the picker


float huu; //picked hue
float bri; //picked brightness
float sat; //picked saturation
color pick; //picked color


float r, g, b; //rgb values of pickes color
float rgb; // grayscale value of picked color



float xx, yy; //main field
float yyy; // hue slider



//color[] c= new color[5];
//color inter1, inter2, inter3, inter4;


// images
PImage bw, footerw, footerb;

int counter;
//boolean sshow;

// comparing colors
//float rr, gg, bb, rrr, ggg, bbb;
//float score;
//float scorepoint; // score position on the scale


 PFont font;
 
 
 color circle;
 
 
 
 // ==================== for the shape
 
float re1, re2, gr1, gr2, bl1, bl2, sa1, sa2, br1, br2;


float min=45;
float max= 285;
float half=285;
float handle=150;


// main points

float ry, gy, by; 

// modes
int top, bot;
boolean zmooth;

int order;



float mmax=150;


// adjusting handle
float aa, bb, alpha, aaa, bbb;

// buttons
PImage buttonsw, buttonsb;


// ==========================================





void setup(){
  size(1248, 800);
  
  

  bw=loadImage("bw.png");
  footerw=loadImage("footerw.png");
  footerb=loadImage("footerb.png");
  buttonsw=loadImage("buttonsw.png");
  buttonsb=loadImage("buttonsb.png");

  
  


  
  
  xx=shiftx+13;
  yy=shifty+13;
  yyy=shifty+1+127;
  
  
  huu=124;
  sat=12.75;
  bri=242;
  
  colorMode(RGB, 255, 255, 255);
  
  //for(int x=0; x<5; x++){
    
  // c[x]=color(random(255), random(255), random(255)); 
  //}
  
  
  white=color(255); // white
  black=color(0); // black
  
  back=white; 
  counter=2; // bw switch
  
  //sshow=false; // clicking show button
  
  font = loadFont("GothamRounded-Book-24.vlw");
  textFont(font);
  textSize(24);
  textAlign(CENTER);
  
  circle=black;
  
  rgb=255;
  
 
  order=1;
  
 //shape
 ry=-half;
 gy=0;
 by=half;
 
 top=1;
 bot=1;
 zmooth=false;
 
  
 

}





// ==========================================





void draw(){
  if(counter%2==0){
   back=white; 
  }
  else
  {
    back=black;
  }
  
  
  //c[2]=black;
  
  
  background(back);
  
  
  
  
  
  
 
// ========== COLOR PICKER

colorMode(HSB, 255, 255, 255);

//hue slider
 noStroke();
 for(int x=0; x<256; x++){
   fill(x, 255, 255);
   rect(shiftx+(256*cell)+shifth, x+shifty, band, cell);
  }  
   
   //frame for hue slider
 noFill();
 if(back==white){
 stroke(0, 0, 0);
 }
 else{
 stroke(0, 0, 255);
 }
 
 rect(shiftx+(256*cell)+shifth-1, shifty-1, band+1, (cell*256)+1);
  
  
  
  
  //main field
  noStroke();
 for(int y=0; y<256; y++){
  for(int x=0; x<256; x++){
    satu=x;
    brig=255-y;
   fill(huu, satu, brig);
   rect(x+shiftx, y+shifty, cell, cell);

  }
 }
 
 //frame for main field
 noFill();
 if(back==white){
 stroke(0, 0, 0);
 }
 else{
 stroke(0, 0, 255);
 }
 rect(shiftx-1, shifty-1, (cell*256)+1, (cell*256)+1);
 
 
 //hue slider action
 if(mousePressed == true && ((mouseX >=shiftx+(256*cell)+shifth && mouseX<=shiftx+(256*cell)+shifth+band-1) && (mouseY>=shifty && mouseY<=shifty+(256*cell)-1))){
 //cursor(CROSS);
   huu=hue(get(mouseX, mouseY));
   
   
   

 }
 
 //hue slider action
 
 noFill();
   if(back==white){
 stroke(0, 0, 0);
 }
 else{
 stroke(0, 0, 255);
 }
   line(shiftx+(256*cell)+shifth-1, yyy, shiftx+(256*cell)+shifth-1-10, yyy);
   
   line(shiftx+(256*cell)+shifth+band, yyy, shiftx+(256*cell)+shifth+10+band, yyy);
 
 
 //main field action
 if(mousePressed == true && ((mouseX >=shiftx && mouseX<shiftx+(256*cell)) && (mouseY>=shifty && mouseY<=shifty+(256*cell)-1))){
 
   sat=mouseX-shiftx;
   bri=255-(mouseY-shifty);
   
   r=red(get(mouseX, mouseY));
   g=green(get(mouseX, mouseY));
   b=blue(get(mouseX, mouseY));
   
   rgb=((r * 0.2126) + (g* 0.7152) + (b * 0.0722));
   
   

 }
 
 
 //circle in the main field
 noFill();

   stroke(255-rgb);
   ellipse(xx, yy, 20, 20);
 
 
 
 pick=color(huu, sat, bri);
 
 
 

 
 
 

 ///////////// ======================================================= SHAPE
 

 
 noStroke();
 

  
  // initial numbers

    colorMode(RGB, 255, 255, 255);
  re1=red(pick);
  gr1=green(pick);
  bl1=blue(pick);
  
  re2=map(re1, 0, 255, min, max);
  gr2=map(gr1, 0, 255, min, max);
  bl2=map(bl1, 0, 255, min, max);
  


  noStroke();
  fill(pick);
  
 
   pushMatrix();
   translate(shifty+half, shifty+half);
   
   
   // COMPOSITE SHAPE. variation of vertices.
   
   // =========================== left half
   
   if((bot==2 || bot==3) && (top==2 || top==3)){
     
   zmooth=false;  
   }
   
   
   
   
   beginShape(); 
   
   // ---------- vertex 1   
   if(top==1){
   vertex(0, ry);
   }
   
   if(top==2){
   vertex(0, ry);
   }
   
   if(top==3){
   vertex(0, ry);
   }
   
   // ---------- vertex 2
   if(top==1){
   vertex(-re2, ry);
   }
   
   if(top==2){
   vertex(-re2, ry);
   }
   
   if(top==3){
   vertex(-re2, ry);
   }
   
   // ---------- vertex 3
   if(top==1){
   vertex(-gr2, gy);
   }
   
   if(top==2 && zmooth==false){
   bezierVertex(-re2, ry+handle, -gr2, gy-handle, -gr2, gy);
   }
   
   if(top==3 && zmooth==false){
   bezierVertex(-re2-handle, ry, -gr2, gy-handle, -gr2, gy);
   }
   
        // zmooth ... straight bottom, curve top vertical handle
        
        if((bot==1 && top==2) && zmooth==true){ // 
          
            if(gr2>bl2){
    aa=gr2-bl2;
    bb=half; 
    alpha=atan(aa/bb);
      
    aaa=(handle*sin(alpha))+gr2;
    bbb=(handle*cos(alpha)); 
            }
            
            if(gr2<bl2){   
    aa=bl2-gr2;
    bb=half; 
    alpha=atan(aa/bb);
      
    aaa=gr2 - (handle*sin(alpha));
    bbb=(handle*cos(alpha)); 
        }
        
        bezierVertex(-re2, ry+handle, -aaa, -bbb, -gr2, gy);
               
        }
        
        
        
        // zmooth ... straight bottom, curve top horizontal handle
        
        if((bot==1 && top==3) && zmooth==true){ // 
          
            if(gr2>bl2){
    aa=gr2-bl2;
    bb=half; 
    alpha=atan(aa/bb);
      
    aaa=(handle*sin(alpha))+gr2;
    bbb=(handle*cos(alpha)); 
            }
            
            if(gr2<bl2){   
    aa=bl2-gr2;
    bb=half; 
    alpha=atan(aa/bb);
      
    aaa=gr2 - (handle*sin(alpha));
    bbb=(handle*cos(alpha)); 
        }
        
        bezierVertex(-re2-handle, ry, -aaa, -bbb, -gr2, gy);
               
        }
   
   
   
   // ---------- vertex 4
   if(bot==1){
   vertex(-bl2, by);
   }
   
   if(bot==2 && zmooth==false){
   bezierVertex(-gr2, gy+handle, -bl2, by-handle, -bl2, by);
   }
   
   if(bot==3 && zmooth==false){
   bezierVertex(-gr2, gy+handle, -bl2-handle, by, -bl2, by);
   }
   
   
        // zmooth ... straight top, curve bottom vertical handle
        
        if((bot==2 && top==1) && zmooth==true){ // 
          
            if(gr2>re2){
    aa=gr2-re2;
    bb=half; 
    alpha=atan(aa/bb);
      
    aaa=(handle*sin(alpha))+gr2;
    bbb=(handle*cos(alpha)); 
            }
            
            if(gr2<re2){
    aa=re2-gr2;
    bb=half; 
    alpha=atan(aa/bb);
      
    aaa=gr2-(handle*sin(alpha));
    bbb=(handle*cos(alpha));  
        }
        
        bezierVertex(-aaa, bbb, -bl2, by-handle, -bl2, by); 
               
        }
        
        
         // zmooth ... straight top, curve bottom horizontal handle
        
        if((bot==3 && top==1) && zmooth==true){ // 
          
            if(gr2>re2){
    aa=gr2-re2;
    bb=half; 
    alpha=atan(aa/bb);
      
    aaa=(handle*sin(alpha))+gr2;
    bbb=(handle*cos(alpha)); 
            }
            
            if(gr2<re2){
    aa=re2-gr2;
    bb=half; 
    alpha=atan(aa/bb);
      
    aaa=gr2-(handle*sin(alpha));
    bbb=(handle*cos(alpha));  
        }
        
        bezierVertex(-aaa, bbb, -bl2-handle, by, -bl2, by); 
               
        }
   
   
   
   
   
   
   
   
   
   // ---------- vertex 5
   if(bot==1){
   vertex(0, by);
   }
   
   if(bot==2){
   vertex(0, by);
   }
   
   if(bot==3){
   vertex(0, by);
   }
   
   endShape();
   
   
   // =========================== right half
   
   beginShape(); 
   
   // ---------- vertex 1   
   if(top==1){
   vertex(0, ry);
   }
   
   if(top==2){
   vertex(0, ry);
   }
   
   if(top==3){
   vertex(0, ry);
   }
   
   
   // ---------- vertex 2
   if(top==1){
   vertex(re2, ry);
   }
   
   if(top==2){
   vertex(re2, ry);
   }
   
   if(top==3){
   vertex(re2, ry);
   }
   
   // ---------- vertex 3
   if(top==1){
   vertex(gr2, gy);
   }
   
   if(top==2 && zmooth==false){
   bezierVertex(re2, ry+handle, gr2, gy-handle, gr2, gy);
   }
   
   if(top==3 && zmooth==false){
   bezierVertex(re2+handle, ry, gr2, gy-handle, gr2, gy);
   }
   
   
   // zmooth ... straight bottom, curve top vertical handle
        
        if((bot==1 && top==2) && zmooth==true){
          
            if(gr2>bl2){
    aa=gr2-bl2;
    bb=half; 
    alpha=atan(aa/bb);
      
    aaa=(handle*sin(alpha))+gr2;
    bbb=(handle*cos(alpha)); 
            }
            
            if(gr2<bl2){   
    aa=bl2-gr2;
    bb=half; 
    alpha=atan(aa/bb);
      
    aaa=gr2 - (handle*sin(alpha));
    bbb=(handle*cos(alpha)); 
        }
        
        bezierVertex(re2, ry+handle, aaa, -bbb, gr2, gy);
               
        }
        
        // zmooth ... straight bottom, curve top horizontal handle
        
        if((bot==1 && top==3) && zmooth==true){ // 
          
            if(gr2>bl2){
    aa=gr2-bl2;
    bb=half; 
    alpha=atan(aa/bb);
      
    aaa=(handle*sin(alpha))+gr2;
    bbb=(handle*cos(alpha)); 
            }
            
            if(gr2<bl2){   
    aa=bl2-gr2;
    bb=half; 
    alpha=atan(aa/bb);
      
    aaa=gr2 - (handle*sin(alpha));
    bbb=(handle*cos(alpha)); 
        }
        
        bezierVertex(re2+handle, ry, aaa, -bbb, gr2, gy);
               
        }
   
   
   
   
   // ---------- vertex 4
   if(bot==1){
   vertex(bl2, by);
   }
   
   if(bot==2 && zmooth==false){
   bezierVertex(gr2, gy+handle, bl2, by-handle, bl2, by);
   }
   
   if(bot==3 && zmooth==false){
   bezierVertex(gr2, gy+handle, bl2+handle, by, bl2, by);
   }
   
   
   // zmooth ... straight top, curve bottom vertical handle
        
        if((bot==2 && top==1) && zmooth==true){ // 
          
            if(gr2>re2){
    aa=gr2-re2;
    bb=half; 
    alpha=atan(aa/bb);
      
    aaa=(handle*sin(alpha))+gr2;
    bbb=(handle*cos(alpha)); 
            }
            
            if(gr2<re2){
    aa=re2-gr2;
    bb=half; 
    alpha=atan(aa/bb);
      
    aaa=gr2-(handle*sin(alpha));
    bbb=(handle*cos(alpha));  
        }
        
        bezierVertex(aaa, bbb, bl2, by-handle, bl2, by); 
               
        }
        
        // zmooth ... straight top, curve bottom horizontal handle
        
        if((bot==3 && top==1) && zmooth==true){ // 
          
            if(gr2>re2){
    aa=gr2-re2;
    bb=half; 
    alpha=atan(aa/bb);
      
    aaa=(handle*sin(alpha))+gr2;
    bbb=(handle*cos(alpha)); 
            }
            
            if(gr2<re2){
    aa=re2-gr2;
    bb=half; 
    alpha=atan(aa/bb);
      
    aaa=gr2-(handle*sin(alpha));
    bbb=(handle*cos(alpha));  
        }
        
        bezierVertex(aaa, bbb, bl2+handle, by, bl2, by); 
               
        }
   
   
   
   
   
   
   // ---------- vertex 5
   if(bot==1){
   vertex(0, by);
   }
   
   if(bot==2){
   vertex(0, by);
   }
   
   if(bot==3){
   vertex(0, by);
   }
   
   endShape();
   

 popMatrix();
 
 
 // ========================================== shape buttons
   
   if(back==white){
   image(buttonsw, 839, 477);
   
    if((top==1 || bot==1) && ((top==2 || top==3) || (bot==2 || bot==3))){
    noStroke();
    fill(white, 0);
    rect(839, 477, 91, 38);
    }
    else{
     noStroke();
    fill(white);
    rect(839, 477, 91, 38); 
    }
   
   
   }
   else
   {     
   image(buttonsb, 839, 477);  
   
   if((top==1 || bot==1) && ((top==2 || top==3) || (bot==2 || bot==3))){
    noStroke();
    fill(black, 0);
    rect(839, 477, 91, 38);
    }
    else{
     noStroke();
    fill(black);
    rect(839, 477, 91, 38); 
    }
   }
   
   
   
   // markers
   
   noFill();
   if(back==white){
    stroke(black); 
   }
   else
   {     
    stroke(white); 
   }
   
   if(top==1){
     
   rect(835, 565, 45, 45);  
     
   }
   
   if(top==2){
     
   rect(888, 565, 45, 45);  
     
   }
   
   if(top==3){
     
   rect(941, 565, 45, 45);  
     
   }
   
   
   if(bot==1){
     
   rect(835, 618, 45, 45);  
     
   }
   
   if(bot==2){
     
   rect(888, 618, 45, 45);  
     
   }
   
   if(bot==3){
     
   rect(941, 618, 45, 45);  
     
   }
   
   
   if((top==1 || bot==1) && ((top==2 || top==3) || (bot==2 || bot==3))){
     
     
    if(zmooth==false){
     
   rect(835, 473, 45, 45);  
     
   }
   
   if(zmooth==true){
     
   rect(888, 473, 45, 45);  
     
   } 

   }
   
   // dimming
   
   noStroke();
   
   
   if(back==white){
     
    fill(white, 50); 
   }
   else
   {
     
    fill(black, 50);  
   }
   
   
   rect(836, 474, 280, 187);
   
   
   
   
  
  
  //=================================== buttons and images
  

  

  
  //footer
 if(back==white){
   image(footerb, 0, height-50); 
  }
  else
  {
   image(footerw, 0, height-50);  
  }
  
  
 



// divider
if(back==white){
    stroke(220);
  }
  else
  {
    stroke(50);
  }
  
  line(750, 0, 750, 749);




}





// ==========================================





void mousePressed(){
  
  if((mouseX >=shiftx && mouseX<=shiftx+(256*cell)) && (mouseY>=shifty && mouseY<=shifty+(256*cell)-1)){
   xx=mouseX;
   yy=mouseY; 
    
  }
  
  if((mouseX >=shiftx+(256*cell)+shifth && mouseX<=shiftx+(256*cell)+shifth+band-1) && (mouseY>=shifty && mouseY<=shifty+(256*cell)-1)){
  
    yyy=mouseY;
    
  }
  
  // bw button
  if ((mouseX>=1120 && mouseX <=1120+38) && (mouseY>=622 && mouseY <= 622+38)){
    counter=counter+1;

  }
  
  
  

  
  if((mouseX>839 && mouseX<839+38) && (mouseY > 569 && mouseY < 569+38)){
   
    top=1;
    
  }
  
  if((mouseX>892 && mouseX<892+38) && (mouseY > 569 && mouseY < 569+38)){
   
    top=2;
    
  }
  
  if((mouseX>945 && mouseX<945+38) && (mouseY > 569 && mouseY < 569+38)){
   
    top=3;
    
  }
  
  
if((mouseX>839 && mouseX<839+38) && (mouseY > 622 && mouseY < 622+38)){
   
    bot=1;
    
  }
  
  if((mouseX>892 && mouseX<892+38) && (mouseY > 622 && mouseY < 622+38)){
   
    bot=2;
    
  }
  
  if((mouseX>945 && mouseX<945+38) && (mouseY > 622 && mouseY < 622+38)){
   
    bot=3;
    
  }
  
  
 if((top==1 || bot==1) && ((top==2 || top==3) || (bot==2 || bot==3))){
   
   
 if((mouseX>839 && mouseX<839+38) && (mouseY > 477 && mouseY < 477+38)){
   
    zmooth=false;
    
  }
  
  if((mouseX>892 && mouseX<892+38) && (mouseY > 477 && mouseY < 477+38)){
   
    zmooth=true;
    
  }  
   
   
 }
  
  
  
  
  
}





// ==========================================





void mouseDragged(){
  
  if((mouseX >=shiftx && mouseX<=shiftx+(256*cell)) && (mouseY>=shifty && mouseY<=shifty+(256*cell)-1)){
   xx=mouseX;
   yy=mouseY; 
    
  }
  
  if((mouseX >=shiftx+(256*cell)+shifth && mouseX<=shiftx+(256*cell)+shifth+band-1) && (mouseY>=shifty && mouseY<=shifty+(256*cell)-1)){
  
    yyy=mouseY;
    
  }

}




// ==========================================



void keyPressed(){
  
  
  
  
  
 if(key=='1'){ // top straight
   top=1;
 }
 
 if(key=='2'){ //top bezier vertical
   top=2;
  
 }
 
 if(key=='3'){ // top bezier horizontal
   top=3;
  
 }
 
 if(key=='4'){ // bottom straight
   bot=1;
 }
 
 if(key=='5'){ // bottom bezier vertical
   bot=2;
 
 }
 
 if(key=='6'){ // bottom bezier horizontal
   bot=3;

 }
 
 if(key=='7'){ // broken joint between bezier and straight
 zmooth=false;
   
 }
 if(key=='8'){ // smooth joint between bezier and straight
 zmooth=true;
  
 }
  

  
 
  println("top: "+top);
  println("bottom: " + bot);
  println("smooth: "+zmooth);
  
  
  
}
